/*
Copyright (C) 2006 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef DIALOGMEMORYREGIONS_20061101_H_
#define DIALOGMEMORYREGIONS_20061101_H_

#include "ui_dialogmemoryregions.h"
#include "MemoryRegions.h"
class QSortFilterProxyModel;


class DialogMemoryRegions : public QDialog {
	Q_OBJECT
public:
	DialogMemoryRegions(QWidget *parent = 0);

private:
	virtual void showEvent(QShowEvent *event);
	
public Q_SLOTS:
	void on_tableView_customContextMenuRequested(const QPoint &pos);	
	void setAccessNone();
	void setAccessR();
	void setAccessW();
	void setAccessX();
	void setAccessRW();
	void setAccessRX();
	void setAccessWX();
	void setAccessRWX();
	
public:
	MemRegion *selectedRegion() const;
	
private:
	void setPermissions(bool read, bool write, bool execute);
	
private:
	Ui::DialogMemoryRegions	ui;
	QSortFilterProxyModel	*m_FilterModel;
};

#endif
